/*
 * Created on 17.06.2004
 */
package calculator_fullControl;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

/**
 * @author markus
 */
public class Calculator {

	boolean stop = false;
	ArrayList plugins = new ArrayList();
	
	Calculator(){
		System.out.println("starte calculator");
		
		//plugin verzeichnis nach plugins durchsuchen und laden
		System.out.println("suche nach Plugins");
		File file = new File("./bin/calculator_fullControl/plugin");
		File[] pluginFiles = file.listFiles();
		for (int i = 0; pluginFiles!=null && i < pluginFiles.length; i++) {
			File tempFile = pluginFiles[i];
			String fileName = tempFile.getName();
			if(fileName.substring(fileName.length()-5,tempFile.getName().length()).equals("class")){
				String className = fileName.substring(0,fileName.length()-6);
				System.out.println("Plugin: "+className);
				try {
					
					//Pluginklasse laden
					Class clazz = Class.forName("calculator_fullControl.plugin."+className);
					plugins.add((IPlugin)clazz.newInstance());
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	
	public static void main(String[] args) {
		new Calculator().start();
	}
	
	public void start(){
		while(!stop){			
			//Men anzeigen
			printMenue();
			
			//Men Eingabe entgegen nehmen
			int menuEingabe = readMenuInput("[Men] Auswahl: ");
			
			//Verarbeitung an Plugin abgeben
			((IPlugin)plugins.get(menuEingabe)).processAction(new BufferedReader(new InputStreamReader(System.in)),System.out);
		}

	}
	
	public void readInput(){
		System.out.print("Eingabe: ");
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			int eingabe = Integer.parseInt(reader.readLine());
			int eingabeMin = 0;
			int eingabeMax = plugins.size();
			if(eingabe>=eingabeMin && eingabe<=eingabeMax){
				if(eingabe==0){
					System.exit(0);
				}
				
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
	public void printMenue(){
		//Men anzeigen
		System.out.println("\n********** Calculator Menue***********");
		for (int i = 0; i < plugins.size(); i++) {
			System.out.println("["+i+"] "+((IPlugin)plugins.get(i)).getDescription());				
		}
		System.out.println("\n[x] Programm beenden");
		System.out.println("**************************************");
	}
	
	public int readMenuInput(String anzeige){
		System.out.print(anzeige);
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			String eingabe = reader.readLine();
			if(eingabe.equals("x")){
				System.exit(0);
			}
			int eingabeMin = 0;
			int eingabeMax = plugins.size()-1;
			int eingabeInt = Integer.parseInt(eingabe);
			if(eingabeInt>=eingabeMin && eingabeInt<=eingabeMax){
				return eingabeInt;			
			}
			else{
				System.exit(0);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 0;
	}
}
