/*
 * Created on 19.06.2004
 */
package calculator_lazyLoading;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

/**
 * @author markus
 */
public class PluginProxy implements IPlugin{
	
	String className;
	String fullClassName;
	String propertiesFileName;
	Properties properties;
	IPlugin instance;
	
	public PluginProxy(String className){
		this.className = className;
		this.fullClassName = "calculator_lazyLoading.plugin."+className;
		this.propertiesFileName = "bin/calculator_lazyLoading/plugin/"+className + ".properties";
	}

	public String getDescription() {
		loadProperties();
		return properties.getProperty("description");
	}

	public int calculate(int a, int b) {
		return getPluginInstance().calculate(a,b);
	}
	
	private void loadProperties(){
		if(properties==null){
			properties = new Properties();
			try {
				properties.load(new FileInputStream(propertiesFileName));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	private IPlugin getPluginInstance(){
		if(instance==null){
			try {
				Class clazz = Class.forName(fullClassName);
				instance = (IPlugin)clazz.newInstance();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return instance;
		
	}

}
