/*
 * Created on 17.06.2004
 */
package calculator_reflection;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;

/**
 * @author markus
 */
public class Calculator {

	boolean stop = false;
	ArrayList pluginClasses = new ArrayList();
	ArrayList pluginInstances = new ArrayList();
	
	Calculator(){
		System.out.println("starte calculator");
		
		////////////////////////////////////////////////////
		//plugin Verzeichnis nach Pluginklassen durchsuchen
		///////////////////////////////////////////////////
		System.out.println("suche nach Plugins");
		File file = new File("./bin/calculator_reflection/plugin");
		File[] pluginFiles = file.listFiles();
		for (int i = 0; pluginFiles!=null && i < pluginFiles.length; i++) {
			File tempFile = pluginFiles[i];
			String fileName = tempFile.getName();
			if(fileName.substring(fileName.length()-5,tempFile.getName().length()).equals("class")){
				String className = fileName.substring(0,fileName.length()-6);
				System.out.println("Plugin: "+className);
				try {
					//////////////////////////////////////
					//Pluginklasse laden und instanziieren
					//////////////////////////////////////
					Class clazz = Class.forName("calculator_reflection.plugin."+className);
					pluginClasses.add(clazz);
					pluginInstances.add(clazz.newInstance());
				} catch (ClassNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	
	public static void main(String[] args) {
		new Calculator().start();
	}
	
	public void start(){
		while(!stop){			
			//Men anzeigen
			printMenue();
			
			//Men Eingabe entgegen nehmen
			int menuEingabe = readMenuInput("[Men] Auswahl: ");
			
			//1.Zahl entgegen nehmen
			int zahl1 = readInput("[Men] Bitte erste Zahl eingeben: ");
			
			//2.Zahl entgegen nehmen
			int zahl2 = readInput("[Men] Bitte zweite Zahl eingeben: ");
			
			//Berechnung im Plugin veranlassen
			int ergebnis = 0;
			try {
				ergebnis = ((Integer)getCalculateMethod((Class)pluginClasses.get(menuEingabe))
							.invoke(pluginInstances.get(menuEingabe),
									new Object[]{new Integer(zahl1), new Integer(zahl2)})).intValue();
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			//Ausgabe des Ergebnisses
			System.out.println("[Men] Ergebnis: "+ergebnis);
		}
	}
	
	public Method getDescriptionMethod(Class clazz){
		Method m = null;
		try {
			m = clazz.getMethod("getDescription",null);
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return m;
	}
	
	public Method getCalculateMethod(Class clazz){
		Method m = null;
		try {
			m = clazz.getMethod("calculate",new Class[]{int.class, int.class});
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return m;
	}
	
	public void printMenue(){
		//Men anzeigen
		System.out.println("\n********** Calculator Menue***********");
		for (int i = 0; i < pluginClasses.size(); i++) {
			try {
				System.out.println("["+i+"] "+(getDescriptionMethod((Class)pluginClasses.get(i)).invoke(pluginInstances.get(i),null)));
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}				
		}
		System.out.println("\n[x] Programm beenden");
		System.out.println("**************************************");
	}
	
	public int readInput(String anzeige){
		System.out.print(anzeige);
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			return Integer.parseInt(reader.readLine());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 0;
	}
	
	public int readMenuInput(String anzeige){
		System.out.print(anzeige);
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			String eingabe = reader.readLine();
			if(eingabe.equals("x")){
				System.exit(0);
			}
			int eingabeMin = 0;
			int eingabeMax = pluginClasses.size()-1;
			int eingabeInt = Integer.parseInt(eingabe);
			if(eingabeInt>=eingabeMin && eingabeInt<=eingabeMax){
				return eingabeInt;			
			}
			else{
				System.exit(0);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 0;
	}
}
